#include <iostream>

using namespace std;

int main() {
	int h, n;
	cin>>h>>n;
	int a[h][n];
	int b[h+1][n];
	
	for(int i=0; i<h; i++){
		for(int j=0; j<n; j++){
			cin>>a[i][j];
		}
	}
	
	for(int i=0; i<n; i++){
		b[0][i]=1;	
	}
	for(int i=1; i<h+1; i++){
		for(int j=0; j<n; j++){
			b[i][j]=0;
		}
	}
	
	for(int i=1; i<h+1; i++){
		for(int j=0; j<n; j++){
			if(a[i-1][j]==1){
				b[i][j]+=b[i-1][j];
			}
			else{
				int levo, desno, poz_levi;
				if(b[i-1][j]%2==0){
					levo=b[i-1][j]/2;
					desno=levo;
				}
				else{
					levo=b[i-1][j]/2+i%2;
					desno=b[i-1][j]/2+(i+1)%2;
				}
				
				for(int z=j-1; z>=0; z--){
					if(a[i-1][z]==1){
						b[i][z]+=levo;
						levo=0;
						poz_levi=z;
						break;
					}
				}
				if(levo!=0){
					desno+=levo;
				}
				
				for(int z=j+1; z<n; z++){
					if(a[i-1][z]==1){
						b[i][z]+=desno;
						desno=0;
						break;
					}
				}
				if(desno!=0){
					b[i][poz_levi]+=desno;
				}
			}
		}
	}
	
	cout<<endl<<endl;
	for(int i=0; i<h+1; i++){
		for(int j=0; j<n; j++){
			cout<<b[i][j]<<" ";
		}
		cout<<endl;
	}
	
	return 0;
}